

proc menugen {} {
    global env

    set f [open [file join $env(MIDASBASE) exodiam_Current_VXI_Configuration]]
    set config [split [read $f] \n]
    close $f

    catch {unset level1}
    catch {unset level2}
    foreach item $config {
        if {$item == ""} {continue}
        if {[string range [first $item] 0 0] == "#"} {continue}
        set m [first [split [first $item] .]]
        switch -glob $m {
            Trigger*   {set t $m}
            ADC*       {set t [string range $m 0 7]}
            default    {set t [first [split $m 0123456789]]}
        }
        if {![info exists level1($t)] || [lsearch $level1($t) $m] == -1} {lappend level1($t) $m}
        lappend level2($m) [first $item]
    }

    catch {unset menu}
    foreach item1 [lsort -dictionary [array names level1]] {  ;#  eg item1= ECC
        set menu1 [list $item1]
        foreach item2 $level1($item1) {                       ;#  eg item2= ECC0 ECC1 ECC2 etc
            set menu2 [list $item2]
            foreach item3 $level2($item2) {                   ;#  eg  item3= ECC0.A.6MeV etc
                lappend menu2 $item3
            }
            lappend menu1 [lsort -dictionary $menu2]
        }
        lappend menu [lsort -dictionary $menu1]
    }

    :modify FRED :menu $menu
}
