

#    MIDAS Access Client  for the  AGATADataBaseAccess service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global AGATADataBaseAccessServerHost AGATADataBaseAccessServerPort

if {[info exists AGATADataBaseAccessServerHost] == 0} then {set AGATADataBaseAccessServerHost localhost}
if {[info exists AGATADataBaseAccessServerPort] == 0} then {set AGATADataBaseAccessServerPort 8015}

variable uri "urn:AGATADataBaseAccessServer"
variable proxy "http://$AGATADataBaseAccessServerHost:$AGATADataBaseAccessServerPort/AGATADataBaseAccessServer"


SOAP::create AGATADataBaseAccessClient__nodes -proxy $proxy -uri $uri -timeout 1000 \
     -name nodes \
     -params {nodeName string pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADataBaseAccessClient__set -proxy $proxy -uri $uri -timeout 1000 \
     -name set \
     -params {nodeName string valueName string data string type string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply
     
SOAP::create AGATADataBaseAccessClient__get -proxy $proxy -uri $uri -timeout 1000 \
     -name get \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADataBaseAccessClient__delete -proxy $proxy -uri $uri -timeout 1000 \
     -name delete \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply
     
SOAP::create AGATADataBaseAccessClient__values -proxy $proxy -uri $uri -timeout 1000 \
     -name values \
     -params {nodeName string pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADataBaseAccessClient__type -proxy $proxy -uri $uri -timeout 1000 \
     -name type \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADataBaseAccessClient__AccessServerVerbose -proxy $proxy -uri $uri -timeout 1000 \
     -name AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

package provide AGATADataBaseAccessClient 1.0
